'------------------------------------------------------------
'
' Installing and Removing Services
'
' Eric Asbell (RobotBob) March 2003
' This program should accompany the
' MyService Example
'
' You could turn this example into a
' command tool with options, pass args to
' the functions, etc...
'
'------------------------------------------------------------

#COMPILE EXE
#DIM ALL
#INCLUDE "Win32API.inc"

GLOBAL schSCManager AS DWORD
GLOBAL schService AS DWORD
GLOBAL sStatus AS SERVICE_STATUS

GLOBAL ServiceName AS STRING
GLOBAL DisplayName AS STRING
GLOBAL PathToServiceEXE AS STRING

GLOBAL ServiceNamePtr AS STRING PTR
GLOBAL DisplayNamePtr AS STRING PTR
GLOBAL PathToServiceEXEPtr AS STRING PTR

FUNCTION PBMAIN
    '-----------------------------------------------------------
    ' Your Service Stuff
    '-----------------------------------------------------------
    ' 'Real' name of the service. From the service itself
    ServiceName = "MyService"
    ' The name displayed in the SCM and sent to functions
    ' query its display name
    DisplayName = "Service Example"
    ' Full path to the service, it can be anywhere you wish.
    PathToServiceEXE  = "C:\Service\MyService.exe"

    ServiceNamePtr = STRPTR(ServiceName)
    DisplayNamePtr = STRPTR(DisplayName)
    PathToServiceEXEPtr = STRPTR(PathToServiceEXE)

    ' Here are the two functions.
    ' I have commented out the second line.
    ' Your job is to reuse this, I made no effort to make this
    ' a full app. Reuse the functions in your own service installer :)
    ' Remember these will fail if you try to remove a non
    ' existing service or add an existing service.

    CALL PBInstallService
    'call PBRemoveService

 FUNCTION = 1
END FUNCTION


'------------------------------------------------------------
' Installs a Service
' then starts it
'------------------------------------------------------------
SUB PBInstallService
    LOCAL dwStatus AS DWORD

    schSCManager = OpenSCManager(BYVAL 0&, BYVAL 0&, %SC_MANAGER_ALL_ACCESS)

    IF schSCManager = %NULL THEN
        EXIT SUB
    END IF

    schService = CreateService(schSCManager, _
         BYVAL ServiceNamePtr,BYVAL DisplayNamePtr, %SERVICE_ALL_ACCESS,_
         %SERVICE_WIN32_OWN_PROCESS OR %SERVICE_INTERACTIVE_PROCESS,_
         %SERVICE_AUTO_START, _
         %SERVICE_ERROR_NORMAL, BYVAL PathToServiceEXEPtr, BYVAL 0&,_
         BYVAL 0&, BYVAL 0&, BYVAL 0&, BYVAL 0&)

    IF schService = %NULL THEN
       CALL MessageBox(0,"CreateService Failed", BYVAL ServiceNamePtr, 0)
       GOTO Finish
    END IF

    IF QueryServiceStatus(schService, sStatus )  = %NULL THEN
        CALL MessageBox(0, "QueryServiceStatus Failed" ,BYVAL ServiceNamePtr, 0)
        GOTO Finish
    END IF

    IF sStatus.dwCurrentState = %SERVICE_STOPPED THEN
            IF StartService(schService, 0, 0) = %NULL THEN
               CALL MessageBox(0,"StartService Failed", BYVAL ServiceNamePtr, 0)
               GOTO Finish
            END IF
    END IF

    CALL MessageBox(0,"Service Installed!", BYVAL ServiceNamePtr, 0)
Finish:
    CALL CloseServiceHandle(schService)
    CALL CloseServiceHandle(schSCManager)

END SUB

'------------------------------------------------------------
' Removes a Service
' Stops it , then Deletes the
' SCManager Entry not the exe
'------------------------------------------------------------
SUB PBRemoveService
    LOCAL dwStatus AS DWORD

    schSCManager = OpenSCManager(BYVAL 0&,BYVAL 0&, %SC_MANAGER_ALL_ACCESS)

    IF schSCManager = %NULL THEN
        MSGBOX "openfailed"
        EXIT SUB
    END IF

    schService = OpenService(schSCManager, BYVAL STRPTR(ServiceName), %SERVICE_ALL_ACCESS)

    IF schService = %NULL THEN
       CALL MessageBox(0,"OpenService Failed", BYVAL ServiceNamePtr, 0)
       GOTO Finish
    END IF

    IF ControlService(schService, %SERVICE_CONTROL_STOP, sStatus) = 0 THEN
        CALL MessageBox(0,"Unable To Stop Service", BYVAL ServiceNamePtr, 0)
    END IF

'----------------------------------------
' Loop until its stopped, then delete it
' it only deletes the SCM entry, not the
' Executable.
'----------------------------------------
DO

    IF QueryServiceStatus(schService, sStatus ) = %NULL THEN
        CALL MessageBox(0,"QueryServiceStatus Failed",BYVAL ServiceNamePtr, 0)
        GOTO Finish
    END IF

    IF sStatus.dwCurrentState = %SERVICE_STOPPED THEN
             IF DeleteService(schService) = %NULL THEN
               CALL MessageBox(0,"Unable To Remove Service", BYVAL ServiceNamePtr, 0)
               GOTO Finish
             END IF
             CALL MessageBox(0,"Service Removed!", BYVAL ServiceNamePtr, 0)
             GOTO Finish
    END IF

LOOP

Finish:
    CALL CloseServiceHandle(schService)
    CALL CloseServiceHandle(schSCManager)

END SUB
